From da9f1b947127d770e6592815f82c6985e3eab4b1 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 12 2021 06:11:13 +0000
Subject: [PATCH 2103/2232] Improve span of shared struct Drop error


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 235ffa0..639880d 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -274,9 +274,11 @@ fn expand_struct_operators(strct: &Struct) -> TokenStream {
 fn expand_struct_forbid_drop(strct: &Struct) -> TokenStream {
     let ident = &strct.name.rust;
     let generics = &strct.generics;
+    let span = ident.span();
+    let impl_token = Token![impl](strct.visibility.span);
 
-    quote! {
-        impl #generics self::Drop for super::#ident #generics {}
+    quote_spanned! {span=>
+        #impl_token #generics self::Drop for super::#ident #generics {}
     }
 }
 
diff --git a/tests/ui/drop_shared.stderr b/tests/ui/drop_shared.stderr
index a215ddf..47db21e 100644
--- a/tests/ui/drop_shared.stderr
+++ b/tests/ui/drop_shared.stderr
@@ -1,10 +1,8 @@
 error[E0119]: conflicting implementations of trait `ffi::_::forbid::Drop` for type `ffi::Shared`:
- --> $DIR/drop_shared.rs:1:1
+ --> $DIR/drop_shared.rs:3:5
   |
 1 | #[cxx::bridge]
-  | ^^^^^^^^^^^^^^
-  | |
-  | first implementation here
-  | conflicting implementation for `ffi::Shared`
-  |
-  = note: this error originates in an attribute macro (in Nightly builds, run with -Z macro-backtrace for more info)
+  | -------------- first implementation here
+2 | mod ffi {
+3 |     struct Shared {
+  |     ^^^^^^^^^^^^^ conflicting implementation for `ffi::Shared`

